// battery status patched for Dell 7559 i5-6300HQ
// create by crackself credit @ RehabMan

DefinitionBlock ("", "SSDT", 2, "hack", "batt", 0)
{
    External(\_SB.PCI0, DeviceObj)
    External(\_SB.PCI0.LPCB, DeviceObj)
    External(\_SB.PCI0.LPCB.EC, DeviceObj)
    External(\_SB.PCI0.LPCB.BAT0, DeviceObj)
    External(\_SB.PCI0.LPCB.BAT0._BST, DeviceObj)
    External(\_SB.PCI0.LPCB.BAT0._BIT, DeviceObj)
    External(\_SB.PCI0.LPCB.ECOK, MethodObj)
    External(\_SB.PCI0, DeviceObj)
    
    Scope(\_SB.PCI0.LPCB.EC)
    {
        // This is an override for battery methods that access EC fields
        // larger than 8-bit.
        OperationRegion (ECRM, EmbeddedControl, Zero, 0x0100)
        Field (ECRM, ByteAcc, Lock, Preserve)
        {
            //...
            //Offset (0x9D), 
            //SBF0,   8, 
            Offset (0xA0),
            DAP0,8,DAP1,8,         //CAP0,   16
            ,   16, //RCP0,   16,
            WOT0,8,WOT1,8,         //VOT0,   16
            DRT0,8,DRT1,8,         //CRT0,   16
            ,   16, //BTM0,   16,
            ,   16, //BST0,   16,
            ,   16, //BRC0,   16,
            GCP0,8,GCP1,8,         //FCP0,   16
            ECP0,8,ECP1,8,         //DCP0,   16
            EVT0,8,EVT1,8,         //DVT0,   16
            ,   16, //VOT0,   16,
            ,   16, //B0C1,   16,
            CSN0,8,CSN1,8,         //BSN0,   16
            ,   16, //MAS0,   16,
            //...
        }        
    }


    
    Scope (_SB.PCI0.LPCB)
    {
        Method (_BST, 0, NotSerialized)  // _BST: Battery Status
            {
                If (ECOK ())
                {
                    Acquire (^^EC.MUTX, 0xFFFF)
                    Store (^^EC.B0DC, Local0)
                    Store (^^EC.B0IC, Local1)
                    ShiftLeft (Local1, One, Local1)
                    Add (Local0, Local1, Local0)
                    Store (^^EC.B0CL, Local1)
                    Release (^^EC.MUTX)
                    ShiftLeft (Local1, 0x02, Local1)
                    Add (Local0, Local1, Local0)
                    Store (Local0, Index (BFB0, Zero))
                    Acquire (^^EC.MUTX, 0xFFFF)
                    Store (B1B2(^^EC.DAP0,^^EC.DAP1), Index (BFB0, 0x02))
                    Store (B1B2(^^EC.WOT0,^^EC.WOT1), Index (BFB0, 0x03))
                    Release (^^EC.MUTX)
                    Acquire (^^EC.MUTX, 0xFFFF)
                    Store (B1B2(^^EC.DRT0,^^EC.DRT1), Local0)
                    Release (^^EC.MUTX)
                    If (LEqual (Local0, Zero))
                    {
                        Increment (Local0)
                    }
                    ElseIf (PWRS)
                    {
                        If (And (Local0, 0x8000))
                        {
                            Store (Ones, Local0)
                        }
                    }
                    ElseIf (And (Local0, 0x8000))
                    {
                        Subtract (Zero, Local0, Local0)
                        And (Local0, 0xFFFF, Local0)
                    }
                    Else
                    {
                        Store (Ones, Local0)
                    }

                    Store (Local0, Index (BFB0, One))
                }

                Return (BFB0)
            }
       
       Method (B1B2, 2, NotSerialized)
        {
            Return (Or (Arg0, ShiftLeft (Arg1, 0x08)))
        }     
   
        Method (_BIF, 0, Serialized)  // _BIF: Battery Information
            {
                Name (_T_2, Zero)  // _T_x: Emitted by ASL Compiler
                Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If (ECOK ())
                {
                    Acquire (^^EC.MUTX, 0xFFFF)
                    Store (B1B2 (^^EC.ECP0, ^^EC.ECP1), Index (PAK0, One))
                    Store (B1B2 (^^EC.GCP0, ^^EC.GCP1), Local0)
                    Store (Local0, Index (PAK0, 0x02))
                    Store (B1B2 (^^EC.EVT0, ^^EC.EVT1), Index (PAK0, 0x04))
                    Store (^^EC.DNN0, Local1)
                    Store (B1B2 (^^EC.CSN0, ^^EC.CSN1), Local2)
                    Store (^^EC.BCN0, Local3)
                    Store (^^EC.MNN0, Local4)
                    Release (^^EC.MUTX)
                    Store (Divide (Local0, 0x0A, ), Index (PAK0, 0x05))
                    Store (Zero, Index (PAK0, 0x06))
                    While (One)
                    {
                        Store (ToInteger (Local1), _T_0)
                        If (LEqual (_T_0, Zero))
                        {
                            Store ("Unknow", Index (PAK0, 0x09))
                        }
                        ElseIf (LEqual (_T_0, 0xFF))
                        {
                            Store ("Dell", Index (PAK0, 0x09))
                        }

                        Break
                    }

                    Store (ITOS (ToBCD (Local2)), Index (PAK0, 0x0A))
                    While (One)
                    {
                        Store (ToInteger (Local3), _T_1)
                        If (LEqual (_T_1, Zero))
                        {
                            Store ("Unknow", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, One))
                        {
                            Store ("PBAC", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x02))
                        {
                            Store ("LION", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x03))
                        {
                            Store ("NICD", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x04))
                        {
                            Store ("NIMH", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x05))
                        {
                            Store ("NIZN", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x06))
                        {
                            Store ("RAM", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x07))
                        {
                            Store ("ZNAR", Index (PAK0, 0x0B))
                        }
                        ElseIf (LEqual (_T_1, 0x08))
                        {
                            Store ("LIP", Index (PAK0, 0x0B))
                        }

                        Break
                    }

                    While (One)
                    {
                        Store (ToInteger (Local4), _T_2)
                        If (LEqual (_T_2, Zero))
                        {
                            Store ("Unknown", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, One))
                        {
                            Store ("Dell", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x02))
                        {
                            Store ("SONY", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x03))
                        {
                            Store ("SANYO", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x04))
                        {
                            Store ("PANASONIC", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x05))
                        {
                            Store ("SONY_OLD", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x06))
                        {
                            Store ("SDI", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x07))
                        {
                            Store ("SIMPLO", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x08))
                        {
                            Store ("MOTOROLA", Index (PAK0, 0x0C))
                        }
                        ElseIf (LEqual (_T_2, 0x09))
                        {
                            Store ("LGC", Index (PAK0, 0x0C))
                        }

                        Break
                    }
                }

                Return (PAK0)
            }
    }
}

